
#include <stdio.h>
#include "PyramidPack.cc"
extern "C"
{
   
#include "io-util.h"
};


#include <stdlib.h>
void _decodeOnce(int _height, int _width,int _color,unsigned char *out,unsigned char *lowLow, unsigned char * lowHigh, unsigned char *highLow,unsigned char *highHigh)
{
   int  *tmp, *tTmp;
   tmp=new int[_height*_width*_color+1];
   unsigned char *tLow,*tHigh;

   printf("333333333333333333333\n");
   printf("_height=%d _width=%d \n",_height,_width);
       
   
       // restore vertically first
   int halfWidth=(_width>>1);
   
   for(int i=0;i<halfWidth;i++)// left half
      {
         tTmp=tmp+i*_color;
         tLow=lowLow+i*_color;
         tHigh=highLow+i*_color;
         for(int j=0;j<_height;j+=2,tTmp+=(_width<<1)*_color,tLow+=halfWidth*_color,tHigh+=halfWidth*_color)
            {
                   /*
               *tTmp=(int)(*tLow)-(int)(*tHigh)+128;
               *(tTmp+_width)=(int)(*tLow)+(int)(*tHigh)-128;
               */
               for(int k=0;k<_color;k++)
                  {
                     
                     *(tTmp+k)=(int)(*(tLow+k))-(int)(*(tHigh+k))+128;
                     *(tTmp+k+_width*_color)=(int)(*(tLow+k))+(int)(*(tHigh+k))-128;
                  }
               
            }
      }
       
   for(int i=halfWidth;i<_width;i++) //right half
      {
         tTmp=tmp+i*_color;
         tLow=lowHigh+(i-halfWidth)*_color;
         tHigh=highHigh+(i-halfWidth)*_color;
         
         for(int j=0;j<_height;j+=2,tTmp+=(_width<<1)*_color,tLow+=halfWidth*_color,tHigh+=halfWidth*_color )
            {
                   /*
               *tTmp=*tLow-*tHigh;
               *(tTmp+_width*_color)=(int)*tLow+(int)*tHigh-256;
               */
               for(int k=0;k<_color;k++)
                  {
                     *(tTmp+k)=*(tLow+k)-*(tHigh+k);
                    *(tTmp+k+_width*_color)=(int)*(tLow+k)+(int)*(tHigh+k)-256;  
                  }
               
            }
      }

       
       // restore horizontally
   
   unsigned char * tOut;
   tOut=out;
   tTmp=tmp;
   
   for(int i=0;i<_height;i++, tTmp+=halfWidth*_color)
      {
         for( int j=0;j<halfWidth;j++,tOut+=2*_color,tTmp+=_color)
            {
                   /*
               *tOut=(unsigned char )(  *tTmp-*(tTmp+halfWidth) );
                   
               *(tOut+1)=(unsigned char )(*tTmp+*(tTmp+halfWidth));
               */
               for(int k=0;k<_color;k++)
                  {
                     *(tOut+k)=(unsigned char )(  *(tTmp+k)-*(tTmp+k+halfWidth*_color) );
                     
                     *(tOut+k+_color)=(unsigned char )(*(tTmp+k)+*(tTmp+k+halfWidth*_color));  
                  }
               
            }
      }
      
   printf("3333333333333333333333333333333333333333\n");
}

void _decodeOnce(unsigned char *low, unsigned char *high, int &rows,int &cols, int &colors,unsigned char **out)
{
   int len[4];
   int noOfBlocks;
   unsigned char **local;
   local=new (unsigned char *)[4];
   
       // here noOfBlocks refer to No Of Bloks in on data pack.
   unpack(low,noOfBlocks,rows, cols,colors,local,len);
   unpack(high,noOfBlocks,rows, cols, colors,local+noOfBlocks,len+noOfBlocks);

   *out=new (unsigned char)[rows*cols*colors<<2];
   
   
   _decodeOnce(rows,cols,colors,*out,local[0],local[1],local[2],local[3]);
   
}


/*
int main()
{
  
   unsigned char **in;
   int rows,cols,colors;

   in=new (unsigned char *)[4];

   for(int i=0;i<4;i++)
      {
         unsigned char filename[30];
         sprintf(filename,"Test%d.pgm",i);
         read_ppm_BYTE(filename,in+i,&rows,&cols);
         
      }
   unsigned char * out;
   colors=3;
   
   
   out=new (unsigned char)[rows*cols*colors<<2+1];
   
   _decodeOnce(rows<<1, cols<<1,3,out,in[0], in[1], in[2],in[3]);
   
   write_ppm_BYTE("TestOut.ppm",out,rows<<1,cols<<1,"");
   
       
}
*/
