/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#define MALLOC malloc 
#define FREE free
#define TRUE  1
#define FALSE 0

#include <fcntl.h>
#include <math.h>
#include <ctype.h>
int ppm_gets(FILE *fdin,unsigned char (*s)[]);

void write_ppm_BYTE(unsigned char *filename,unsigned char *data,int rows, int cols,   unsigned char *comment);

int read_ppm_BYTE(unsigned char *name,unsigned char **image, int *rows, int *cols);

int read_ppm_BYTE_withpreallcatedMemory(unsigned char *name,unsigned char *image, int *rows, int *cols);


int get_pgm_image_size(unsigned char *name, int *inrows, int *incols);

int read_pgm_BYTE(unsigned char *name,unsigned char **image, int *rows, int *cols);

int write_pgm_BYTE(unsigned char*name,unsigned char *image, int rows, int cols, unsigned char *comment);


