/*******************************
 *
 *  VideoSRMChannelSever.h
 *
 *  $Id: VideoSRMChannelSever.h,v 2.1 1999/05/05 22:59:09 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef VideoSRMChannelSever_H
#define VideoSRMChannelSever_H
class VideoSRMSever;
#include "VideoSRMSever.h"
#include "SRMChannelSever.h"



class VideoSRMChannelSever:public SRMChannelSever
{
private:
   void copy(const VideoSRMChannelSever & src);
   void cleanup();



   int channelID;
   static VideoSRMSever * videoSever;
//   VideoSRMSever * videoSever;
   static int ok;
   
 
public:
   
   VideoSRMChannelSever();
   VideoSRMChannelSever(unsigned int _addr,
                        unsigned int _port,
                        unsigned int _ttl,
                        int _channelID,
                        VideoSRMSever * _videoSever);
   void init(unsigned int _addr,
                 unsigned int _port,
                 unsigned int _ttl,
                 int _channelID);

   
   
   VideoSRMChannelSever(const VideoSRMChannelSever & that);
   virtual ~VideoSRMChannelSever();

   VideoSRMChannelSever & operator=(const VideoSRMChannelSever &that);
   int operator==(const VideoSRMChannelSever &right);
   int operator!=(const VideoSRMChannelSever &right);
   
   void debug(void * p);

//   void sendData( int frameNo, unsigned char *data, int len);
   
   static void srm_recv(srm_source_t source,
                        unsigned int cid,
                        unsigned int seqno ,
                        const unsigned char *data,
                        int len,
                        const srm_adu_info * info);
   
   static int srm_should_recover(srm_source_t source,
                                 unsigned int cid,
                                 unsigned int ss,
                                 unsigned int es);
   
   static void srm_read_adu(srm_source_t source,
                            unsigned int cid,
                            unsigned int seqno ,
                            unsigned char **data_ptr,
                            unsigned int *len_ptr,
                            srm_free_proc *free_proc_ptr,
                            srm_adu_info * info);
   
   static void srm_source_update(srm_source_t source ,
                                 const unsigned char *info,
                                 int len);
static   void decipher(int cid, int &frameNo, int &frameNo);
static   int encodeCid(int channelNo, int frameNo, unsigned char * videoName);
 void  _sendData(int channelID, int seqNo, unsigned char *data, int len);
   
};

#endif /* VideoSRMChannelSever_H */

